RDKit: RDKit::DGeomHelpers::EmbedParameters Struct Reference

| RDKit Open-source cheminformatics and machine learning.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | List of all members
RDKit::DGeomHelpers::EmbedParameters Struct Reference

Parameter object for controlling embedding. More...

`#include <Embedder.h>`

## Public Member Functions
| EmbedParameters ()
| EmbedParameters (unsigned int maxIterations, int numThreads, int randomSeed, bool clearConfs, bool useRandomCoords, double boxSizeMult, bool randNegEig, unsigned int numZeroFail, const std::map< int, RDGeom::Point3D > *coordMap, double optimizerForceTol, bool ignoreSmoothingFailures, bool enforceChirality, bool useExpTorsionAnglePrefs, bool useBasicKnowledge, bool verbose, double basinThresh, double pruneRmsThresh, bool onlyHeavyAtomsForRMS)

## Public Attributes
unsigned int | maxIterations
int | numThreads
int | randomSeed
bool | clearConfs
bool | useRandomCoords
double | boxSizeMult
bool | randNegEig
unsigned int | numZeroFail
const std::map< int, RDGeom::Point3D > * | coordMap
double | optimizerForceTol
bool | ignoreSmoothingFailures
bool | enforceChirality
bool | useExpTorsionAnglePrefs
bool | useBasicKnowledge
bool | verbose
double | basinThresh
double | pruneRmsThresh
bool | onlyHeavyAtomsForRMS

## Detailed Description

Parameter object for controlling embedding.

numConfs Number of conformations to be generated

numThreads Sets the number of threads to use (more than one thread will only be used if the RDKit was build with multithread support) If set to zero, the max supported by the system will be used.

maxIterations Max. number of times the embedding will be tried if coordinates are not obtained successfully. The default value is 10x the number of atoms.

randomSeed provides a seed for the random number generator (so that the same coordinates can be obtained for a molecule on multiple runs). If negative, the RNG will not be seeded.

clearConfs Clear all existing conformations on the molecule

useRandomCoords Start the embedding from random coordinates instead of using eigenvalues of the distance matrix.

boxSizeMult Determines the size of the box that is used for random coordinates. If this is a positive number, the side length will equal the largest element of the distance matrix times `boxSizeMult`. If this is a negative number, the side length will equal `-boxSizeMult` (i.e. independent of the elements of the distance matrix).

randNegEig Picks coordinates at random when a embedding process produces negative eigenvalues

numZeroFail Fail embedding if we find this many or more zero eigenvalues (within a tolerance)

pruneRmsThresh Retain only the conformations out of 'numConfs' after embedding that are at least this far apart from each other. RMSD is computed on the heavy atoms. Prunining is greedy; i.e. the first embedded conformation is retained and from then on only those that are at least `pruneRmsThresh` away from already retained conformations are kept. The pruning is done after embedding and bounds violation minimization. No pruning by default.

coordMap a map of int to Point3D, between atom IDs and their locations their locations. If this container is provided, the coordinates are used to set distance constraints on the embedding. The resulting conformer(s) should have distances between the specified atoms that reproduce those between the points in `coordMap`. Because the embedding produces a molecule in an arbitrary reference frame, an alignment step is required to actually reproduce the provided coordinates.

optimizerForceTol set the tolerance on forces in the DGeom optimizer (this shouldn't normally be altered in client code).

ignoreSmoothingFailures try to embed the molecule even if triangle bounds smoothing fails

enforceChirality enforce the correct chirality if chiral centers are present

useExpTorsionAnglePrefs impose experimental torsion-angle preferences

useBasicKnowledge impose "basic knowledge" terms such as flat aromatic rings, ketones, etc.

verbose print output of experimental torsion-angle preferences

basinThresh set the basin threshold for the DGeom force field, (this shouldn't normally be altered in client code).

onlyHeavyAtomsForRMS only use the heavy atoms when doing RMS filtering

Definition at line 302 of file Embedder.h.

## Constructor & Destructor Documentation

RDKit::DGeomHelpers::EmbedParameters::EmbedParameters | ( |  | ) |
| inline

Definition at line 321 of file Embedder.h.

RDKit::DGeomHelpers::EmbedParameters::EmbedParameters | ( | unsigned int | maxIterations,
|  | int | numThreads,
|  | int | randomSeed,
|  | bool | clearConfs,
|  | bool | useRandomCoords,
|  | double | boxSizeMult,
|  | bool | randNegEig,
|  | unsigned int | numZeroFail,
|  | const std::map< int, RDGeom::Point3D > * | coordMap,
|  | double | optimizerForceTol,
|  | bool | ignoreSmoothingFailures,
|  | bool | enforceChirality,
|  | bool | useExpTorsionAnglePrefs,
|  | bool | useBasicKnowledge,
|  | bool | verbose,
|  | double | basinThresh,
|  | double | pruneRmsThresh,
|  | bool | onlyHeavyAtomsForRMS
| ) |  |
| inline

Definition at line 340 of file Embedder.h.

References RDKit::DGeomHelpers::ETDG, RDKit::DGeomHelpers::ETKDG, and RDKit::DGeomHelpers::KDG.

## Member Data Documentation

double RDKit::DGeomHelpers::EmbedParameters::basinThresh

Definition at line 318 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

double RDKit::DGeomHelpers::EmbedParameters::boxSizeMult

Definition at line 308 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::clearConfs

Definition at line 306 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

const std::map<int, RDGeom::Point3D>* RDKit::DGeomHelpers::EmbedParameters::coordMap

Definition at line 311 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::enforceChirality

Definition at line 314 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::ignoreSmoothingFailures

Definition at line 313 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

unsigned int RDKit::DGeomHelpers::EmbedParameters::maxIterations

Definition at line 303 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

int RDKit::DGeomHelpers::EmbedParameters::numThreads

Definition at line 304 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMultipleConfs().

unsigned int RDKit::DGeomHelpers::EmbedParameters::numZeroFail

Definition at line 310 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::onlyHeavyAtomsForRMS

Definition at line 320 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

double RDKit::DGeomHelpers::EmbedParameters::optimizerForceTol

Definition at line 312 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

double RDKit::DGeomHelpers::EmbedParameters::pruneRmsThresh

Definition at line 319 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::randNegEig

Definition at line 309 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

int RDKit::DGeomHelpers::EmbedParameters::randomSeed

Definition at line 305 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::useBasicKnowledge

Definition at line 316 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::useExpTorsionAnglePrefs

Definition at line 315 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::useRandomCoords

Definition at line 307 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

bool RDKit::DGeomHelpers::EmbedParameters::verbose

Definition at line 317 of file Embedder.h.

Referenced by RDKit::DGeomHelpers::EmbedMolecule(), and RDKit::DGeomHelpers::EmbedMultipleConfs().

The documentation for this struct was generated from the following file:

- Embedder.h